#!/bin/bash

g++ -std=c++11 -Wall -O3 -o sol matej_10b.cpp
g++ -std=c++11 -Wall -O3 -o gen gen.cpp


readonly MAX_N=500000
readonly MAX_M=500000
readonly TENTH_N=50000

generate_small(){
	./gen 276206	1 d0 5 10 > data/01a.in
	./gen 4676132	1 c0 5 3 2 > data/01b.in
	./gen 12		5 t0 1 t0 1 t0 1 t0 1 t0 1 > data/01c.in
	./gen 67515		1 t0 5 > data/01d.in
	./gen 87941		2 t0 2 ru 3 5 > data/01e.in
	./gen 872146 	2 t0 3 tu 2 > data/01f.in
	./gen 451321	2 d0 3 4 t0 2 > data/01g.in
}

generate_connected(){
	./gen 4671345	1 t0 $MAX_N > data/03a.in
	./gen 1357872	1 d0 $TENTH_N $MAX_M > data/03b.in
	./gen 4536123	1 tu $MAX_N > data/03c.in
	./gen 4321587	1 r0 $TENTH_N $MAX_M > data/03d.in
	./gen 8975412	1 c0 $MAX_N $TENTH_N 101 > data/03e.in
	./gen 9876543	1 c0 $MAX_N 3 $TENTH_N > data/03f.in
	./gen 9701236	1 ru $TENTH_N $MAX_M > data/03g.in
}

# $1 .. cislo
# $2 .. 0/u
# POZOR!!! Neni tak jednoduche upravit pro zmenu limitu, konzultovat s Matejem!
generate_rest(){
	./gen 121540$1	1 c$2 $MAX_N 3 $TENTH_N  > data/$1a.in
	./gen 786531$1	3 x0 $TENTH_N t$2 1 x0 $TENTH_N t$2 6 r$2 $TENTH_N 150000 > data/$1b.in
	./gen 746135$1	5 x0 200 d$2 100 1000 x0 20 d$2 5000 10000 x0 10 r$2 1000 3000 tu 50000 x0 10 t0 1 > data/$1c.in
	./gen 456232$1	3 x0 20 d$2 10 30 r$2 $TENTH_N 495000 x0 10 t0 1 > data/$1d.in
	./gen 865323$1	3 x0 1000 d$2 20 50 x0 300 r$2 200 1000 x0 10 t0 1 > data/$1e.in
	./gen 453123$1	5 x0 100 tu 300 x0 100 t$2 300 x0 10 d$2 5000 15000 r$2 $TENTH_N 150000 x0 10 t0 1 > data/$1f.in
	./gen 977517$1	2 r$2 $TENTH_N $MAX_M x0 10 t0 1 > data/$1g.in
}



generate_small
generate_connected
generate_rest 02 u
generate_rest 04 0

for i in {01..04};
do
	for j in {a..g};
	do
		time ./sol < data/$i$j.in > data/$i$j.out
	done
done
