#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>

#define X first
#define Y second

using namespace std;

int n;

vector<vector<int>> e;
vector<vector<int>> ue;
vector<int> indeg;
vector<int> component;
vector<bool> done;

void dfs(int v, int p = -1){
	if(p == -1) p = v;
	component[v] = p;
	for(auto w : ue[v]) if(component[w] == -1) dfs(w, p);
}

int main(){
	int m;

	cin >> n >> m;

	e.resize(n);
	ue.resize(n);
	indeg.resize(n,0);
	component.resize(n, -1);
	done.resize(n, false);

	int u, v;
	for(int i = 0; i < m; ++i){
		cin >> u >> v;
		--u; --v;
		e[u].push_back(v);
		ue[u].push_back(v);
		ue[v].push_back(u);
		++indeg[v];
	}

	queue<int> q;

	for(int i = 0; i < n; ++i){
		if(component[i]==-1)dfs(i);
		if(indeg[i] == 0) q.push(i);
	}

	while(!q.empty()){
		int u = q.front();
		q.pop();
		done[u]=true;
		for(auto w : e[u]){
			if(--indeg[w] == 0) q.push(w);
		}
	}

	vector<bool> tree_comp(n, false);

	for(int i = 0; i < n; ++i){
		if(component[i] == i) tree_comp[i] = true;
		if(!done[i]) tree_comp[component[i]] = false;
	}

	int res = n;

	for(int i = 0; i < n; ++i) if(tree_comp[i]) --res;

	cout << res << endl;

	
}